From f3ab81287c2cd8296e7230ef10038cba85d4523a Mon Sep 17 00:00:00 2001
From: Minoru Akagi <akaginch@gmail.com>
Date: Mon, 22 Apr 2013 18:41:53 +0900
Subject: [PATCH] fix some memory leaks

---
 src/core/raster/qgscontrastenhancement.cpp | 2 ++
 src/core/raster/qgsrasterinterface.cpp     | 2 ++
 src/core/raster/qgsrasternuller.cpp        | 2 +-
 src/providers/gdal/qgsgdalprovider.cpp     | 1 +
 4 files changed, 6 insertions(+), 1 deletion(-)

diff --git a/src/core/raster/qgscontrastenhancement.cpp b/src/core/raster/qgscontrastenhancement.cpp
index 8cbc1c2..e5e6385 100644
--- a/src/core/raster/qgscontrastenhancement.cpp
+++ b/src/core/raster/qgscontrastenhancement.cpp
@@ -77,6 +77,8 @@ QgsContrastEnhancement::QgsContrastEnhancement( const QgsContrastEnhancement& ce
 
 QgsContrastEnhancement::~QgsContrastEnhancement()
 {
+  delete [] mLookupTable;
+  delete mContrastEnhancementFunction;
 }
 /*
  *
diff --git a/src/core/raster/qgsrasterinterface.cpp b/src/core/raster/qgsrasterinterface.cpp
index 0908cbd..eabca05 100644
--- a/src/core/raster/qgsrasterinterface.cpp
+++ b/src/core/raster/qgsrasterinterface.cpp
@@ -219,6 +219,7 @@ QgsRasterBandStats QgsRasterInterface::bandStatistics( int theBandNo,
         myMean += myDelta / myRasterBandStats.elementCount;
         mySumOfSquares += myDelta * ( myValue - myMean );
       }
+      delete blk;
     }
   }
 
@@ -478,6 +479,7 @@ QgsRasterHistogram QgsRasterInterface::histogram( int theBandNo,
         myHistogram.histogramVector[myBinIndex] += 1;
         myHistogram.nonNullCount++;
       }
+      delete blk;
     }
   }
 
diff --git a/src/core/raster/qgsrasternuller.cpp b/src/core/raster/qgsrasternuller.cpp
index 3ce33b3..6894a13 100644
--- a/src/core/raster/qgsrasternuller.cpp
+++ b/src/core/raster/qgsrasternuller.cpp
@@ -50,9 +50,9 @@ QGis::DataType QgsRasterNuller::dataType( int bandNo ) const
 QgsRasterBlock * QgsRasterNuller::block( int bandNo, QgsRectangle  const & extent, int width, int height )
 {
   QgsDebugMsg( "Entered" );
-  QgsRasterBlock *outputBlock = new QgsRasterBlock();
   if ( !mInput )
   {
+    QgsRasterBlock *outputBlock = new QgsRasterBlock();
     return outputBlock;
   }
 
diff --git a/src/providers/gdal/qgsgdalprovider.cpp b/src/providers/gdal/qgsgdalprovider.cpp
index 8ff1d1c..f6ed583 100644
--- a/src/providers/gdal/qgsgdalprovider.cpp
+++ b/src/providers/gdal/qgsgdalprovider.cpp
@@ -971,6 +971,7 @@ QgsRasterIdentifyResult QgsGdalProvider::identify( const QgsPoint & thePoint, Id
     {
       results.insert( i, value );
     }
+    delete myBlock;
   }
   return QgsRasterIdentifyResult( QgsRasterDataProvider::IdentifyFormatValue, results );
 }
-- 
1.8.0.msysgit.0

